﻿using System;
using CodeHollow.FeedReader;

namespace SharpRss.Models
{
    public class FeedModel
    {
        private FeedModel()
        {
            
        }
        public FeedModel(Feed feed)
        {
            FeedId = Guid.NewGuid().ToString();
            Url = feed.Link;
        }
        
        public string Url { get; set; }
        public string FeedId { get; private set; }
        public string CategoryId { get; set; } = "";

        public static FeedModel Create(string url, string feedId, string categoryId)
        {
            FeedModel feedModel = new FeedModel()
            {
                Url = url,
                FeedId = feedId,
                CategoryId = categoryId
            };
            return feedModel;
        }

        //private readonly Task _fetchTask;
        //public async Task FetchAsync() => _feed = await FeedCache.GetFeed(Url);
        /*private Feed? _feed;
        public Feed Base {
            get
            {
                if (_feed == null)
                {
                    if (_fetchTask.IsFaulted)
                    { return new Feed(); }
                    if (_fetchTask.Status is not (TaskStatus.Running or TaskStatus.WaitingForActivation))
                        _fetchTask.Start();
                    _fetchTask.Wait();
                }
                return _feed ?? new Feed();
            }
        }*/
    }
}
